Name: ovmd
Version: 3.0
Release: 66%{?dist}
Summary: Oracle VM guest daemon
License: GPL
Group: System Environment/Daemons
URL: http://www.oracle.com/virtualization
Source: %{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: libovmapi-devel >= 3.2
Requires: libovmapi >= 3.2
Requires: ovm-template-config >= 3.0

Patch1: dummy.patch
Patch2: sleep-before-start-ovmd.patch
Patch3: remove-sleep-workaround.patch
Patch4: wait-for-ovmapi-ko-to-ready.patch
Patch5: patch8057.patch
Patch6: license-header.patch
Patch7: fix-ol6-console-input.patch
Patch8: change-ovmd-priority.patch
Patch9: initial-config.patch
Patch10: rename-to-initial-config.patch
Patch11: fix-quotation-mark.patch
Patch12: rev102.patch
Patch13: rev104.patch
Patch14: cmd-opts.patch
Patch15: rev108.patch
Patch16: rev118.patch
Patch17: rev128.patch
Patch18: rev137.patch
Patch19: rev139.patch
Patch20: rev141.patch
Patch21: rev143.patch
Patch22: flush-param.patch
Patch23: delete-params-after-configuration.patch
Patch24: disable-initial-config-by-default.patch
Patch25: update-rpm-dependencies.patch
Patch26: remove-xenstoreprovider-dependency.patch
Patch27: rev185.patch
Patch28: rev195.patch
Patch29: rev208.patch
Patch30: rev218.patch
Patch31: rev228.patch
Patch32: rev240.patch
Patch33: rev250.patch
Patch34: rev260.patch
Patch35: alias-handling.patch
Patch36: rev282.patch
Patch37: rev292.patch
Patch38: rev298.patch
Patch39: rev315.patch
Patch40: rev350.patch
Patch41: rev353.patch
Patch42: rev354.patch
Patch43: rev357.patch
Patch44: rev358.patch
Patch45: rev384.patch
Patch46: rev390.patch
Patch47: rev392.patch
Patch48: rev398.patch
Patch49: rev416.patch
Patch50: rev422.patch
Patch51: rev424.patch
Patch52: rev426.patch
Patch53: rev432.patch
Patch54: rev434.patch
Patch55: rev452.patch
Patch56: rev462.patch
Patch57: rev482.patch
Patch58: rev497.patch
Patch59: rev507.patch
Patch60: rev521.patch
Patch61: rev549.patch
Patch62: rev569.patch
Patch63: rev583.patch
Patch64: rev597.patch
Patch65: rev611.patch
Patch66: rev625.patch
Patch67: rev638.patch
# End Oracle Patches

%description
Oracle VM guest daemon.

%prep
%setup -q
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p0
%patch31 -p0
%patch32 -p0
%patch33 -p0
%patch34 -p0
%patch35 -p0
%patch36 -p0
%patch37 -p0
%patch38 -p0
%patch39 -p0
%patch40 -p0
%patch41 -p0
%patch42 -p0
%patch43 -p0
%patch44 -p0
%patch45 -p0
%patch46 -p0
%patch47 -p0
%patch48 -p0
%patch49 -p0
%patch50 -p0
%patch51 -p0
%patch52 -p0
%patch53 -p0
%patch54 -p0
%patch55 -p0
%patch56 -p0
%patch57 -p0
%patch58 -p0
%patch59 -p0
%patch60 -p0
%patch61 -p0 -E
%patch62 -p0 -E
%patch63 -p0 -E
%patch64 -p0 -E
%patch65 -p0 -E
%patch66 -p0 -E
%patch67 -p0 -E

%build
make

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=${RPM_BUILD_ROOT} install

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = 1 ]; then
    /sbin/chkconfig --add ovmd
fi

%preun
if [ "$1" = 0 ]; then
    /sbin/service ovmd stop
    /sbin/chkconfig --del ovmd
fi

%files
%defattr(-,root,root)
%doc COPYING
/etc/init.d/ovmd
%config /etc/sysconfig/ovmd
/usr/sbin/ovmd

%changelog
* Mon Aug 27 2018  <> - 3.0-66 
- Merged branches-7/ovmd-3.7:r635 to trunk.
  ovmd:
  Replaced select with fgets which is restartable after a signal.
  Outchild pipe needs to be kept open to write ovmapi data.
  xenstoreprovider:
  Added restart to SIGIO sa_flags so that syscalls can be restarted after event handling.
  Signed-off-by: Paul Benoit <paul.x.benoit@oracle.com> [bug 27923102]  

* Thu Feb 22 2018 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-65 
- Merged branches-7/ovmd-3.7:r621 to trunk.
  This removes the osolete 30-second timeout on OVMAPI_Register. [bug 27486046]  

* Wed Jan 10 2018 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-64 
- Implemented workaround for unexpected startup script termination during boot process.
  Signed-off-by: Alexandre Khodakovski <alexandre.khodakovski@oracle.com> [bug 23244608]  

* Fri Jan 05 2018 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-63 
- Fixed deadlock between ovmd and ovm-template-config on attempt to exchange parameters.
  Signed-off-by: Alexandre Khodakovski <alexandre.khodakovski@oracle.com> [bug 23244608]  

* Thu Jan 04 2018 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-62 
- Fixed the initial config functionality that the previous change (r569) broke.
  Signed-off-by: Alexandre Khodakovski <alexandre.khodakovski@oracle.com> [bug 23244608]  

* Thu Jan 04 2018 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-61 
- Fixed incorrect use of select() that could cause SIGIO handler to hang.
  Signed-off-by: Alexandre Khodakovski <alexandre.khodakovski@oracle.com> [bug 27250922] [bug 23244608]  

* Tue Dec 05 2017 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-60 
- Handle multiple IPv4 addresses per network interface.
  Signed-off-by: Alexandre Khodakovski <alexandre.khodakovski@oracle.com>
  Reviewed-by: Zhigang Wang <zhigang.x.wang@oracle.com> [bug 27150498]  

* Thu Oct 29 2015 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-59
- Update the build and runtime dependency on libovmapi version >= 3.2

* Thu Oct 29 2015 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-58 
- Reviewed-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Added debug build mode, fixed compiler warnings, fixed the IPChange message for interfaces without IPv6 addresses. 

* Mon Oct 19 2015 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-57 
- Reviewed-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Removed "goto fail" from sendAliveEvent and sendIPChangeInfoMessage. 

* Tue Oct 13 2015 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-56 
- Reviewed-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Synced ovmd trunk and ovmd-3.7 branch. [bug 21877857]  

* Thu Oct 08 2015 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-55 
- fix fgets() error checking
  fgets also returns NULL when end of file occurs while no characters have been read.
  So if a command has no stdout output, then fgets() will return NULL.
  Our logic will not fail at this case, but insted use "unknown".
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Ke-Chiang Chen <ke-chiang.chen@oracle.com> 

* Thu Oct 01 2015 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-54 
- Update version dependency on libovmapi

* Thu Oct 01 2015 Alexandre Khodakovski <alexandre.khodakovski@oracle.com> - 3.0-53 
- Reviewed-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Use ovmjson library from libovmapi package instead of cJSON.c in ovmd and xenstoreprovider. [bug 21877857]  

* Sun Sep 13 2015 Joe Jin <joe.jin@oracle.com> - 3.0-52 
- Add valid check for cJSON_{Print, PrintUnformatted}.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com>
  Reviewed-by: Shin'ya Narahara <shinya.narahara@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Thu Sep 10 2015 Joe Jin <joe.jin@oracle.com> - 3.0-51 
- Add valid check for cJSON_Create{Object,Array}.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com>
  Reviewed-by: Shin'ya Narahara <shinya.narahara@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Thu Sep 10 2015 Joe Jin <joe.jin@oracle.com> - 3.0-50 
- Initialize all pointers to NULL when declare.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com>
  Reviewed-by: Shin'ya Narahara <shinya.narahara@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Thu Sep 10 2015 Joe Jin <joe.jin@oracle.com> - 3.0-49 
- Re-factor DEBUGLOG.
  Add necessary check for system calls.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com>
  Reviewed-by: Shin'ya Narahara <shinya.narahara@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Thu Sep 10 2015 Joe Jin <joe.jin@oracle.com> - 3.0-48 
- Add necessary check for system calls.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com>
  Reviewed-by: Shin'ya Narahara <shinya.narahara@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Thu Sep 10 2015 Joe Jin <joe.jin@oracle.com> - 3.0-47 
- Fix fds leak
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com>
  Reviewed-by: Shin'ya Narahara <shinya.narahara@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Thu Sep 10 2015 Joe Jin <joe.jin@oracle.com> - 3.0-46 
- Fix memory memory leak and potential buffer overflow.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com>
  Reviewed-by: Shin'ya Narahara <shinya.narahara@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Tue Sep 08 2015 Joe Jin <joe.jin@oracle.com> - 3.0-45 
- Add valid check for all malloc() to avoid potential segfault.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Tue Sep 08 2015 Joe Jin <joe.jin@oracle.com> - 3.0-44 
- Fix memory leak.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Tue Sep 08 2015 Joe Jin <joe.jin@oracle.com> - 3.0-43 
- Remove unused variables
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Tue Sep 08 2015 Joe Jin <joe.jin@oracle.com> - 3.0-42 
- Enable gcc warning for makefile
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 21670609] [bug 21670683] [bug 21325065]  

* Tue Oct 07 2014 Carson Hovey <carson.hovey@oracle.com> - 3.0-41 
- ovmd now reports all ipv6 addresses to the OVM Manager UI
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Bug 18473346 - LINUX GUESTS NOT REPORTING ALL CONFIGURED IPV6 ADDRESSES IN OVM MANAGER UI
- Backout check-in 348
- ovmd now reports all ipv6 addresses to the OVM Manager UI
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Oracle-bug: Bug 18473346 - LINUX GUESTS NOT REPORTING ALL CONFIGURED IPV6 ADDRESSES IN OVM MANAGER UI
- Undo 354
- ovmd now reports all ipv6 addresses to the OVM Manager UI
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Oracle-bug: 18473346 - LINUX GUESTS NOT REPORTING ALL CONFIGURED IPV6 ADDRESSES IN OVM MANAGER UI 

* Thu May 30 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-40 
- mark /etc/sysconfig/ovmd as config in rpm 

* Thu Apr 18 2013 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-38 
- Change checked in to makefile 

* Thu Apr 18 2013 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-37 
- Bug 16673614:  Change permissions for install of ovmd sysconfig 

* Thu Apr 18 2013 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-36 
- bug 16673614:  Change permissions for ovmd sysconfig 

* Wed Feb 13 2013 Adnan Misherfi <adnan.misherfi@oracle.com> - 3.0-35 
- Fixed interface  alias handling that caused OVMD to continuously sends IP change event.
  Fixed a socket descriptor leak.
  Do not send interface alias events, as the manager does not handle nor model these events. [bug 16278726]  

* Wed Jan 09 2013 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-34 
- Changes from Wim.  Correctly add OL_OS instead of RHEL_OS as identifier. 

* Tue Dec 18 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-33 
- fix include 

* Tue Dec 18 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-32 
- Bug 16005057:  Increase MAX_NICS 

* Thu Oct 04 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-31 
- Bug 14660397:  Fixed memory leak which would cause eventual segfault. 

* Thu Sep 06 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-30 
- fix for 14005821.  IPv6 address changes will now trigger an IPChange event 

* Wed Sep 05 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-29 
- Change the way ovmd tells the manager that an adapter has gone away.  Works without changes to current manager code. 

* Sun Sep 02 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-28 
- Fix for 14357811.  Rewrote the whole IPChange detection code path. 

* Wed Feb 29 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-27 
- Fix for 13780749, new network code was not properly setting MAC address in string format. 

* Thu Feb 16 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-26 
- remove xenstoreprovider dependency.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Fri Feb 03 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-25 
- update rpm dependencies. 

* Fri Feb 03 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-24 
- disable initial configure by default
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Tue Jan 17 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-23 
- Delete initail configuration parameters after configuration
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Steve Prochniak <steve.prochniak@oracle.com> 

* Fri Jan 13 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-22 
- change --flush-params to --flush-param to keep consistent with other options.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Steve Prochniak <steve.prochniak@oracle.com> 

* Thu Jan 12 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-21 
- fix include 

* Thu Jan 12 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-20 
- implement getParam and cleanup some dysfunctional code 

* Fri Jan 06 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-19 
- Fix #include 

* Fri Jan 06 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-18 
- implement -x, flush params 

* Tue Jan 03 2012 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-17 
- Rewrite of function to get network information for ifChange message 

* Thu Dec 01 2011 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-16 
- Entropy issues - bug 13444561.  Added commandline option for poll delay and a larger default. 

* Fri Nov 18 2011 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-15 
- Add error handling for case of script not found 

* Fri Nov 18 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-14 
- change command line options. 

* Fri Nov 18 2011 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-13 
- fix daemon mode problem 

* Fri Nov 18 2011 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-12 
- Handle RECONFIG event 

* Tue Oct 04 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-11 
- fix quotation mark 

* Wed Sep 28 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-10 
- rename first_config to initial_config [bug 13004324] 

* Wed Sep 28 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-9 
- rename OVMD_CONFIG_MODE to INITIAL_CONFIG
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 13004324] 

* Wed Sep 28 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-8 
- change ovmd service priority. 

* Wed Sep 28 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-7 
- fix console input on ol6 [bug 13004233] 

* Tue Sep 13 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-6 
- add license header 

* Tue Aug 16 2011 Steve Prochniak <steve.prochniak@oracle.com> - 3.0-5 
- Attempt to call OVMAPI_Register more than once.  Should alleviate a startup race condition with the ovmapi driver. 

* Thu Aug 11 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-4 
- give 3 second for ovmapi.ko to get ready. 

* Fri Aug 05 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-3 
- param loss issue has been fixed in xenstoreprovider. remove this workarond. 

* Wed Aug 03 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-2 
- give 3 second for ovmapi.ko to get ready.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Steve Prochniak <steve.prochniak@oracle.com> 

* Mon Jun 06 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 3.0-1 
- Initial build.
